CONFIG += c++14 release

!win32:{
    CONFIG += X64 VS
}
else {
    CONFIG += AVS
    #CONFIG += VS
    CONFIG += X64
    #CONFIG += X32
}

contains(QT_ARCH, arm64):CONFIG += ARM
android:CONFIG += ARM

win32:DEFINES += Q_OS_WIN
unix:!macx:DEFINES += Q_OS_LINUX
macx:DEFINES += Q_OS_MAC
android:DEFINES += Q_OS_ANDROID

AVS:DEFINES += AVISYNTH_PLUGIN
VS: DEFINES += VAPOURSYNTH_PLUGIN
!ARM {
    X64:DEFINES += Q_PROCESSOR_X86_64
    macx:QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.11
}
else {
    DEFINES += Q_PROCESSOR_ARM64
    macx:QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.16
}

QT -= core gui

!win32:!ARM:QMAKE_CXXFLAGS += -msse2 -march=amdfam10
unix:!macx:QMAKE_CXXFLAGS += -fno-sized-deallocation
win32 {
    QMAKE_CXXFLAGS_RELEASE -= -O2
    QMAKE_CXXFLAGS_RELEASE += -O3 -march=amdfam10
    QMAKE_CXXFLAGS += -D_MT -D_DLL
    LIBS += -lKernel32 -lAdvapi32 -lUser32 -lShell32
}
win32 {
    X32:QMAKE_CXXFLAGS += -m32 -msse2
    X64:QMAKE_CXXFLAGS += -m64
    QMAKE_LFLAGS_WINDOWS = -Wl,-subsystem:windows
    QMAKE_LFLAGS += -Wl,-NODEFAULTLIB -lmsvcrt -lucrt -lmsvcprt -lvcruntime
    X32:QMAKE_LFLAGS += -m32
    X64:QMAKE_LFLAGS += -m64
    X64:QMAKE_RC = windres --target=pe-x86-64 --preprocessor=gcc --preprocessor-arg -E --preprocessor-arg -xc-header --preprocessor-arg -DRC_INVOKED
    X64:QMAKE_LIB = ar -rc
}
android {
    QMAKE_CFLAGS += -fPIC
}
